{ =========================================================================== }
{                                 FPTCBAS.PAS                                 }
{ =========================================================================== }

unit FPTCBas;

{$E+,N+,B-,V-,F+,S+,R+}

{ ---> Funcoes, procedimentos, tipos e constantes basicas                     }

interface

uses
  Crt, Printer;

const
  MaxM = 20;  { quantidade maxima de linhas das matrizes  }
  MaxN = 20;  { quantidade maxima de colunas das matrizes }

  CaracterValido: set of char = ['0'..'9', 'a'..'z', 'A'..'Z', '!', '@', '#',
                           '$', '%', '&', '(', ')', '-', '_', '{', '}',
                           '`', '~', '''', #27, '.','?', '*', ' ', ':', '\'];

type
  IndPtr = ^MIndice;
  MIndice = array[1..2000] of word;

  TelaPtr = ^MTela;
  MTela = array[0..3999] of byte;

  MatLogica = record
    calc: array[0..11] of boolean;
    imprimiu: array[0..11] of boolean;
  end;

  real = extended;

  MatPtr = ^matriz;
  matriz = record
    m, n: byte;
    a: array[1..MaxM, 1..(MaxN + 1)] of real;
  end;

  vetor = array[1..MaxN] of real;

  resposta = record
    SolParticular: vetor;
    x: matriz;
    homogeneo, impossivel, SistDet, EqDemais: boolean;
  end;

  InfoPress = record
    brancos, largura, racional, tela, MaxL, opcao: byte;
    ultimo: boolean;
    n: shortint;
  end;

const
  EndTela: word = $B800;  { em videos monocromaticos este valor devera' ser
                            trocado por $B000  }

  MatMenu: array[10..15] of string[80] =
              ('   ' + #26  + ' Prxima coluna     ' + #27 +
                                         ' Coluna anterior     ESC: Volta',
              ' ' + #26 + ' Prx. col. ' + #27 +
                                                ' Col. anter.  ESC: Volta',
              ' Formatando os elementos da matriz...                   ',
              '                  Formatando os elementos da matriz...  ',
              ' Formatando os elementos da coluna...                   ',
              ' Formatando os elementos da coluna...  ');


  ESC = #27; ENTER = #13; Retrocesso = #8;

  F1 = #59; F2 = #60; F3 = #61; F4 = #62; F5 = #63;
  F6 = #64; F7 = #65; F8 = #66; F9 = #67; F10 = #68;

  SetaPCima = #72; SetaPBaixo = #80;
  SetaPEsquerda = #75; SetaPDireita = #77;
  Home = #71;  TeclaEnd = #79;
  PgUp = #73; PgDn = #81;

  AltI = #23; AltT = #20; AltP = #25; AltL = #38;

  mens1: array[0..9] of string[50] =
        ('', ' MATRIZ INVERSA DE M ', ' MATRIZ M ESCALONADA ', ' AUTOVALORES ',
         ' POLINOMIO CARACTERISTICO ', ' M ^ ', ' MATRIZ SEMELHANTE A M ',
         ' POLINOMIO MINIMO ', ' AUTOVETORES ', ' FORMA DE JORDAN ');

  mens2: array[0..10, 1..2] of string[70] =
    (('   F3: Nova matriz    F4: Rac.    F7: Volta     F5: Fim   ',
      '    F3: Nova Matriz    F4: Rac.     F7: Volta     F5: Fim    '),
     (' F2: Salva  F3: Nova matriz  F4: Rac. F7: Volta F8: Troca ',
      ' F2: Salva  F3: Nova matriz  F4: Rac.  F7: Volta   F8: Troca '),
     (' F2: Salva  F3: Nova matriz  F4: Rac. F7: Volta F8: Troca ',
      ' F2: Salva  F3: Nova matriz  F4: Rac.  F7: Volta   F8: Troca '),
     (' F2: Salva F3: Nova matriz F4: Rac. F7: Volta F10: Repete ',
      '  F2: Salva  F3: Nova matriz   F4: Rac.  F5: Fim   F7: Volta '),
     (' F2: Salva F3: Nova matriz F4: Rac. F7: Volta F10: Fatora ',
      ' F2: Salva  F3: Nova matriz  F4: Rac. F7: Volta  F10: Fatora '),
     (' F2: Salva  F3: Nova matriz  F4: Rac. F7: Volta F8: Troca ',
      ' F2: Salva  F3: Nova matriz  F4: Rac.  F7: Volta   F8: Troca '),
     (' F2: Salva  F3: Nova matriz  F4: Rac. F7: Volta F8: Troca ',
      ' F2: Salva  F3: Nova matriz  F4: Rac.  F7: Volta   F8: Troca '),
     (' F3: Nova matriz F4: Rac. F7: Volta  F5: Fim  F10: Repete ',
      '    F3: Nova Matriz    F4: Rac.     F7: Volta     F5: Fim    '),
     ('   F3: Nova matriz    F4: Rac.    F7: Volta     F5: Fim   ',
      '    F3: Nova Matriz    F4: Rac.     F7: Volta     F5: Fim    '),
     (' F3: Nova matriz  F4: Rac. F7: Volta F8: Troca F10: Base  ',
      ' F3: Nova matriz  F4: Rac. F7: Volta   F8: Troca  F10: Base  '),
     (' F3: Nova matriz  F4: Rac. F7: Volta F8: Troca  F5: Fim   ',
      ' F3: Nova matriz  F4: Rac. F7: Volta   F8: Troca  F5: Fim    '));

procedure ExplodeTela(t: TelaPtr; m: MIndice);
procedure AbreCortina(tela: TelaPtr);
procedure FechaCortina(tela: TelaPtr);
procedure LimpaTela(m: MIndice);
procedure SombreiaCaracter(carac: byte);
procedure EsfarelaTela(t: TelaPtr; m: MIndice);
procedure LeIndices(var m: MIndice; nome: string);
procedure MostraTela(tela: TelaPtr);
procedure LeTelaTexto(arq: string; tela: TelaPtr);
procedure SalvaTela(mt: TelaPtr);
procedure RestauraTela(mt: TelaPtr);
function Repete(r: shortint; x: char): string;
function Spc(n: shortint): string;
procedure Cor(x, y: byte);
procedure Cls;
procedure Erro(n, tela: byte; var HouveErro: boolean);
procedure Termina(x, y, CorDeFundo: byte; tela: TelaPtr; ind1: MIndice);
procedure Aproxima(var x: real);
function Rac(x: real; tam1, tam2: byte): string;
procedure FormataElemento(x: real; var tam1, tam2: byte);
procedure ReformataElemento(x: real; var tam1, tam2: byte);
procedure MostraTelasInfo(t: TelaPtr);
procedure Janela2(x, y: byte; mens: string);
procedure Janela(x, y: byte; mens: string; var nome: string);
procedure JanMenuResult(mens: string);
procedure PausaJanMenu(mens: string);
procedure LimpaJanMenu;
function Maiusculas(x: string): string;
procedure Mens(x: string; op: InfoPress);
procedure ModoDeEntrada(var modo: char; var nome: string);

{ =========================================================================== }

implementation

const
  erro4: real = 1E-10;   { usado na funcao Rac             }
  erro5: real = 1E-08;   { usado na funcao Aproxima        }
  decimais: byte = 4;    { quantidade de casas decimais    }
  HaCor: boolean = true; { determina se as telas tem cor   }
  MaxQ: byte = 200;      { maior denominador usado por Rac }

{ --------------------------------------------------------------------------- }

procedure ExplodeTela(t: TelaPtr; m: MIndice);

var
  i: word;

begin
  for i := 1 to 2000 do
  begin
    Mem[EndTela:2*m[i]-2] := t^[2*m[i] - 2];
    Mem[EndTela:2*m[i]-1] := t^[2*m[i] - 1];
  end;
end;

{ --------------------------------------------------------------------------- }

procedure TrocaColTelas(tela: TelaPtr; col: byte);

var
  k: byte;

begin
  for k :=  1 to 25 do
  begin
    Mem[EndTela:2*col + 160*k - 162] := tela^[2*col + 160*k - 162];
    Mem[EndTela:2*col + 160*k - 161] := tela^[2*col + 160*k - 161];
  end;
end;

{ --------------------------------------------------------------------------- }

procedure AbreCortina(tela: TelaPtr);

var
  i: byte;

begin
  for i := 1 to 40 do
  begin
    TrocaColTelas(tela, 41 - i);
    TrocaColTelas(tela, 40 + i);
  end;
end;

{ --------------------------------------------------------------------------- }

procedure FechaCortina(tela: TelaPtr);

var
  i: byte;

begin
  for i := 1 to 40 do
  begin
    TrocaColTelas(tela, i);
    TrocaColTelas(tela, 81 - i);
  end;
end;

{ --------------------------------------------------------------------------- }

procedure LimpaTela(m: MIndice);

var
  i: word;

begin
  for i := 1 to 2000 do
  begin
    Mem[EndTela:2*m[i] - 2] := 0;
    Mem[EndTela:2*m[i] - 1] := 7;
    Delay(1);
  end;
end;

{ --------------------------------------------------------------------------- }

procedure SombreiaCaracter(carac: byte);

var
  i: word;

begin
  for i := 0 to 3836 do
    if (Mem[EndTela:i] = carac) then
    begin
      Mem[EndTela:i + 1] := 7;
      if (Mem[EndTela:i + 162] = Ord(' ')) then
        Mem[EndTela:i + 163] := 0;
    end;
end;

{ --------------------------------------------------------------------------- }

procedure EsfarelaTela(t: TelaPtr; m: MIndice);

var
  i: word;

begin
  for i := 1 to 2000 do
  begin
    Mem[EndTela:2*m[i] - 2] := t^[2*m[i] - 2];
    Mem[EndTela:2*m[i] - 1] := t^[2*m[i] - 1];
    Delay(1);
  end;
end;

{ --------------------------------------------------------------------------- }

procedure LeIndices(var m: MIndice; nome: string);

var
  arq: file of MIndice;

begin
  Assign(arq, nome);
  {$I-}
  Reset(arq);
  {$I+}
  if (IOResult <> 0) then
  begin
    Writeln;
    Writeln(#7, '*** ARQUIVO DE INDICES (', nome, ') NAO ENCONTRADO ***');
    Writeln; Halt;
  end;
  Read(arq, m);
  Close(arq);
end;

{ --------------------------------------------------------------------------- }

procedure LeTelaTexto(arq: string; tela: TelaPtr);

var
  ArqTela: file of MTela;
  x: MTela;

begin
  Assign(ArqTela, arq);
  {$I-}
  Reset(ArqTela);
  {I+}
  if (IOResult <> 0) then
  begin
    Writeln;
    Writeln(#7, '*** ARQUIVO DE TELA (', arq,') NAO ENCONTRADO ***');
    Writeln; Halt;
  end;
  Read(ArqTela, x);
  Close(ArqTela);
  Move(x, tela^, 4000);
end;

{ --------------------------------------------------------------------------- }

procedure MostraTela(tela: TelaPtr);

begin
  Move(tela^, Mem[EndTela:0000], 4000);
end;

{ --------------------------------------------------------------------------- }

procedure SalvaTela(mt: TelaPtr);

begin
  Move(Mem[EndTela:0000], mt^, 4000);
end;

{ --------------------------------------------------------------------------- }

procedure RestauraTela(mt: TelaPtr);

begin
  Move(mt^, Mem[EndTela:0000], 4000);
end;

{ --------------------------------------------------------------------------- }

function Repete(r: shortint; x: char): string;

var
  i: byte;
  s: string[100];

begin
  s := '';
  for i := 1 to r do s := s + x;
  Repete := s
end;

{ --------------------------------------------------------------------------- }

function Spc(n: shortint): string;

begin
  Spc := Repete(n, ' ')
end;

{ --------------------------------------------------------------------------- }

procedure Cor(x, y: byte);

begin
  if HaCor then
  begin
    TextBackground(x);
    TextColor(y);
  end;
end;

{ --------------------------------------------------------------------------- }

procedure Cls;

begin
  Window(1, 1, 80, 25);
  Cor (0, 7);
  ClrScr
end;

{ --------------------------------------------------------------------------- }

procedure Termina(x, y, CorDeFundo: byte; tela: TelaPtr; ind1: MIndice);

var
  ch: char;

begin
  Window(x, y, x + 28, y + 2); Cor(CorDeFundo, 0);
  GoToXY(1, 1); Write(#218, Repete(10, #196), ' FIM ', Repete(10, #196), #191);
  GoToXY(1, 2); Write(#179, Spc(25), #179);
  GoToXY(1, 3); Write(#192, Repete(25, #196), #217);
  GoToXY(4, 2); Write('Tem certeza? (s/n) ');
  repeat
    ch := ReadKey;
  until (UpCase(ch) = 'S') or (UpCase(ch) = 'N');
  Write(ch);
  if (UpCase(ch) = 'N') then
  begin
    RestauraTela(tela);
    Exit;
  end
  else
  begin
    LimpaTela(ind1);
    Cls; Halt;
  end;
end;

{ --------------------------------------------------------------------------- }

procedure Erro(n, tela: byte; var HouveErro: boolean);

var
  c: char;
  esp: byte;

const
  MensErro: array[1..10] of string[70] =
           ('*** ERRO DE GRAVAAO *** ',
            '*** ERRO DE LEITURA *** ',
            '*** ERRO: Nao foi encontrado o arquivo MAT ***',
            '*** ERRO: Esperado um nmero inteiro ***',
            '*** ERRO: Valor invlido ***',
            '*** ERRO: Caracter invlido em nome de arquivo ***',
            '*** ERRO: Matrizes de ordens diferentes ***',
            '*** ERRO: Nao foi possvel calcular a forma de Jordan ***',
            '*** ERRO: Nao  possvel calcular a base neste caso ***',
            '*** ERRO: A matriz P nao tem inversa ***');
begin
  Write(#7); HouveErro := true;
  if (tela = 1) then
  begin
    Window(11, 22, 69, 22); Cor(7, blink);
    esp := (58 - Length(MensErro[n])) div 2;
    Write(Spc(esp), MensErro[n], Spc(58 - esp - Length(MensErro[n])));
  end
  else
  begin
    Window(10, 22, 71, 22); Cor(7, blink);
    esp := (61 - Length(MensErro[n])) div 2;
    Write(Spc(esp), MensErro[n], Spc(61 - esp - Length(MensErro[n])));
  end;
  c := ReadKey;
end;

{ --------------------------------------------------------------------------- }

procedure Aproxima(var x: real);

begin
  if (Abs(x - Int(x)) < erro5) then
    x := Int(x)
  else
    if (1 - Abs(x - Int(x)) < erro5) then
      if (x >= 0) then
        x := 1 + Int(x)
      else
        x := -1 + Int(x);
end;

{ --------------------------------------------------------------------------- }

function Rac(x: real; tam1, tam2: byte): string;

{ ---> escreve o real x no formato racional usando um campo de largura tam1;
       se x nao puder ser escrito na forma p/q com q <= MaxQ ou na forma 1/q
       entao Rac devolve x no formato tam1:tam2                               }

var
  i, j : byte;
  y: real;
  s1, s2: string[10];
  r: string;
  sinal: string[1];

begin
  if (tam1 = 0) then
  begin
    Str(x:tam1, r);
    Rac := r + '  ';
    Exit;
  end;
  if (x < 0) then sinal := '-' else sinal := '';
  y := Abs(x);
  if (Abs(x - Round(x)) < erro4) then
  begin
    Str(Round(x):tam1, r);
    Rac := r;
    Exit;
  end
  else if (Abs(1/y - Round(1/y)) < erro4) then
  begin
    Str(Round(1/y), r);
    r := sinal + '1/' + r;
    if (Length(r) > tam1) then
      Str(x:tam1:tam2, r)
    else
      if (Length(r) < tam1) then
        for i := 1 to tam1 - Length(r) do r := ' ' + r;
    Rac := r;
    Exit;
  end
  else
  begin
    for j := 2 to MaxQ do
      if (Abs(y*j - Round(y*j)) < erro4) then
      begin
        Str(j, s2);
        Str(Round(y*j), s1);
        r := sinal + s1 + '/' + s2;
        if (Length(r) > tam1) then
          Str(x:tam1:tam2, r)
        else
          if (Length(r) < tam1) then
            for i := 1 to tam1 - Length(r) do r := ' ' + r;
        Rac := r;
        Exit;
      end;
  end;
  Str(x:tam1:tam2, r);
  Rac := r;
end;

{ --------------------------------------------------------------------------- }

procedure FormataElemento(x: real; var tam1, tam2: byte);

var
  inteiro: boolean;

begin
  if (Abs(x) > 2147483647) then
  begin
    tam1 := 0; tam2 := decimais;
    Exit;
  end;
  if (x <> Round(x)) then inteiro := false else inteiro := true;
  x := Round(x);
  if (x <> 0) then tam1 := Round(Ln(Abs(x))/Ln(10));
  if ((x = 0) or (tam1 < 1)) then tam1 := 1;
  if inteiro then tam2 := 0 else tam2 := decimais;
  tam1 := tam1 + tam2 + 2;
end;

{ --------------------------------------------------------------------------- }

procedure ReformataElemento(x: real; var tam1, tam2: byte);

var
  s: string;
  k: byte;

begin
  k := 0;
  if (Abs(x) > 2147483647) then Exit;
  s := Rac(x, tam1, tam2);
  while (s[k + 1] = ' ') do Inc(k);
  tam1 := tam1 - k + 2;
end;

{ --------------------------------------------------------------------------- }

procedure MostraTelasInfo(t: TelaPtr);

const
  QuantTelasInfo = 13;

var
  telas: array[1..QuantTelasInfo] of TelaPtr;
  i: byte;
  IndExplosao, IndImplosao: IndPtr;
  ch: char;
  istr: string;

begin
  New(IndExplosao); New(IndImplosao);
  for i := 1 to QuantTelasInfo do
  begin
    New(telas[i]);
    Str(i, istr);
    if HaCor then
      LeTelaTexto('INFO' + istr, telas[i])
    else
      LeTelaTexto('INFO' + istr + '.SCR', telas[i]);
  end;
  LeIndices(IndExplosao^, 'EXPLODE');
  LeIndices(IndImplosao^, 'IMPLODE');
  i := 1;
  ExplodeTela(telas[1], IndExplosao^);
  repeat
    ch := ReadKey;
    if (ch = #0) then
    begin
      ch := ReadKey;
      case ch of
        SetaPEsquerda : if (i > 1) then
                        begin
                          Dec(i);
                          MostraTela(telas[i]);
                        end
                        else
                          Write(#7);

        SetaPDireita : if (i < QuantTelasInfo) then
                       begin
                         Inc(i);
                         MostraTela(telas[i]);
                       end
                       else
                         Write(#7);
      end;
    end;
  until (ch = ESC);
  ExplodeTela(t, IndImplosao^);
  for i := 1 to QuantTelasInfo do Dispose(telas[i]);
  Dispose(IndExplosao); Dispose(IndImplosao);
end;

{ --------------------------------------------------------------------------- }

procedure Janela2(x, y: byte; mens: string);

var
  compr: byte;

begin
  Window(x, y, x + 28, y + 2); Cor(7, 0);
  GoToXY(1, 1);
  Writeln(#218, Repete(25, #196), #191);
  Writeln(#179, Spc(25), #179);
  Write(#192, Repete(25, #196), #217);
  GoToXY(10, 2); Write(mens);
end;

{ --------------------------------------------------------------------------- }

procedure Janela(x, y: byte; mens: string; var nome: string);

var
  a, ch: char;
  xpos, ypos, i, compr: byte;

begin
  Window(x, y, x + 28, y + 2); Cor(7, 0);
  compr := (26 - Length(mens)) div 2; GoToXY(1, 1);
  Write(#218, Repete(compr, #196), mens, Repete(compr, #196), #191);
  GoToXY(1, 2); Write(#179, Spc(25), #179); GoToXY(1, 3);
  Write(#192, Repete(6, #196), ' ESC:  Volta ', Repete(6, #196), #217);
  GoToXY(10, 2);
  nome := '';
  i := 0; xpos :=  WhereX; ypos := WhereY;
  repeat
    ch := ReadKey;
    if (ch <> #0) and (ch <> Retrocesso) then
    begin
      Inc(i);
      if (ch <> ENTER) then nome := nome + ch;
      GoToXY(xpos, ypos); Write('         '); GoToXY(xpos, ypos);
      Write(nome);
    end
    else
    begin
      if (ch = #0) then ch := readkey;
      if (ch = Retrocesso) or (ch = SetaPEsquerda) then
      begin
        Dec(i);
        nome := Copy(nome, 1, i);
        GoToXY(xpos, ypos); Write('         '); GoToXY(xpos, ypos);
        Write(nome);
      end;
    end;
  until (ch = ENTER) or (ch = ESC);
  if (ch = ESC) then
    nome := ESC
  else
  begin
    GoToXY(xpos, ypos); Write('         '); GoToXY(6, 2);
  end;
end;

{ --------------------------------------------------------------------------- }

procedure JanMenuResult(mens: string);

var
  esp, i: byte;

begin
  esp := Trunc((61 - Length(mens))/2);
  Cor(7, 0); Window(11, 11, 70, 20);
  GoToXY(1, 1);
  Write(#218, Repete(esp, #196), mens, Repete(57 - Length(mens) - esp, #196),
                                                                       #191);
  for i := 2 to 9 do
  begin
    GoToXY(1, i); Write(#179, Spc(57), #179);
  end;
  GoToXY(1, i + 1); Write(#192, Repete(57, #196), #217);
end;

{ --------------------------------------------------------------------------- }

procedure PausaJanMenu(mens: string);

var
  c: char;

begin
  Window(11, 11, 70, 20); GoToXY(10, 10);
  Write(' Pressione qualquer tecla para continuar ');
  repeat
    c := ReadKey;
  until (c <> #0);
  JanMenuResult(mens); Window(12, 13, 68, 19);
end;

{ --------------------------------------------------------------------------- }

procedure LimpaJanMenu;

begin
  Window(11, 11, 69, 20); Cor(2, 7); ClrScr;
end;


{ --------------------------------------------------------------------------- }

function Maiusculas(x: string): string;

var
  i: byte;

begin
  for i := 1 to Length(x) do
    if ((x[i] >= 'a') and (x[i] <= 'z')) then
      x[i]  := Chr(Ord(x[i]) - 32);
  Maiusculas := x;
end;

{ --------------------------------------------------------------------------- }

procedure Mens(x: string; op: InfoPress);

var
  i, quant: byte;

begin
  quant := Trunc((op.largura - Length(x) - 2)/2);
  for i := 1 to quant do
    if (op.tela = 1) then Write('-') else Write(Lst, '-');
  if (op.tela = 1) then Write(' ', x, ' ') else Write(Lst, ' ', x, ' ');
  for i := 1 to (op.largura - (quant + 2 + Length(x))) do
    if (op.tela = 1) then Write('-') else Write(Lst, '-');
  if (op.tela = 1) then Writeln else Writeln(Lst);
end;

{ --------------------------------------------------------------------------- }

procedure ModoDeEntrada(var modo: char; var nome: string);

var
  cod: integer;
  i: byte;
  tela: TelaPtr;
  indices: MIndice;

const
  menu: array[1..4] of string[60] =
       ('      SELECIONE O MODO DE ENTRADA DA MATRIZ P     '  ,
        '   [1] A matriz ser' + #160 + ' introduzida pelo teclado     ',
        '   [2] A matriz ser' + #160 + ' carregada do disco           ',
        '   [3] A matriz ser' + #160 + ' gerada aleatoriamente        ');

begin
  New(tela); Window(15, 8, 67, 18);
  if (nome <> '') then
  begin
    Cor(7, blink); GoToXY(2, 2); Write(menu[1]);
  end;
  repeat
    modo := ReadKey;
    if (modo = #0) then
    begin
      modo := ReadKey;
      if (modo = F5) then
      begin
        SalvaTela(tela);
        Termina(42, 17, 7, tela, indices);
        Window(15, 8, 67, 18);
      end;
    end;
  until modo in ['1', '2', '3'];
  Cor(2, 7 + blink);
  case modo of
    '1': begin
           if (nome <> '') then Exit;
           GoToXY(2, 5); Write(menu[2]);
           Janela(42, 17, ' Ordem de M? ', nome);
         end;
    '2': begin
           GoToXY(2, 7); Write(menu[3]);
           Janela(42, 17, ' Nome da Matriz? ', nome);
         end;
    '3': begin
           if (nome <> '') then Exit;
           GoToXY(2, 9); Write(menu[4]);
           Janela(42, 17, ' Ordem de M? ', nome);
         end;
  end;
  Dispose(tela);
end;

{ --------------------------------------------------------------------------- }

var
  arq1: file of real;
  arq2: file of byte;
  erro1, erro2, erro3: real;
  largura, hc: byte;

begin
  Assign(arq1, 'MATRIZES.ERR');
  {$I-}
  Reset(arq1);
  {$I+}
  if (IOResult = 0) then
  begin
    Read(arq1, erro1, erro2, erro3, erro4, erro5);
    Close(arq1);
  end;
  Assign(arq2, 'ALC.DTA');
  {$I-}
  Reset(arq2);
  {$I+}
  if (IOResult = 0) then
  begin
    Read(arq2, decimais, hc, largura, MaxQ);
    HaCor := boolean(hc);
    Close(arq2);
  end;
end.

{ =========================================================================== }

