{ =========================================================================== }
{                                 GRTELAS.PAS                                 }
{ =========================================================================== }

program GrTelas;

{ ---> gera telas coloridas (*.) ou sem cor (*.SCR) e arquivos de indices
       usados por ALC                                                        }

uses
  FPTCBas, Crt;

{ --------------------------------------------------------------------------- }

procedure GeraIndicesEsfarelamento;

{ ---> gera o arquivo de indices para o esfarelamento de telas                }

var
  NSort, quant, i, j, k: word;
  a: MIndice;
  novo: boolean;
  arq: file of MIndice;

begin
  for quant := 1 to 2000 do
  begin
    Randomize;
    repeat
      NSort := Random(2000);
      novo := true;
      for i := 1 to quant - 1 do
        if (a[i] = NSort + 1) then novo := false;
      if novo then a[quant] := NSort + 1;
    until novo;
  end;
  Assign(arq, 'ESFARELA');
  Rewrite(arq);
  Write(arq, a);
  Close(arq);
end;

{ --------------------------------------------------------------------------- }

procedure GeraIndicesExplosao;

{ ---> gera os indices para explosao e implosao de telas                      }

var
  x, y: byte;
  quant, j, i, k: word;
  LimEsq, LimDir, LimSup, LimInf: byte;
  a: array[1..3000] of word;
  n, m: MIndice;
  arq: file of MIndice;
  novo: boolean;

begin
  ClrScr; i := 0;
  LimInf := 25; LimSup := 1; LimEsq := 1; LimDir := 80;
  repeat
    for y := LimSup to LimInf do
    begin
      GoToXY(LimEsq, y); write('*');
      Inc(i); a[i] := 160*(y - 1) + 2*(LimEsq - 1);
    end;
    for y := LimInf downto LimSup do
    begin
      GoToXY(LimEsq + 1, y); write('*');
      Inc(i); a[i]  := 160*(y - 1) + 2*LimEsq;
    end;
    for y := LimSup to LimInf do
    begin
      GoToXY(LimDir, y); write('*');
      Inc(i); a[i] := 160*(y - 1) + 2*(LimDir - 1);
    end;
    for y := LimInf downto LimSup do
    begin
      GoToXY(LimDir - 1, y); write('*');
      Inc(i); a[i] := 160*(y - 1) + 2*(LimDir - 2);
    end;
    for x := LimEsq + 1 to LimDir - 1 do
    begin
      GoToXY(x, LimSup); write('*');
      Inc(i); a[i] := 160*(LimSup - 1) + 2*(x - 1);
    end;
    for x := LimDir - 1 downto LimEsq + 1 do
    begin
      GoToXY(x, LimInf); write('*');
      Inc(i); a[i] := 160*(LimInf - 1) + 2*(x - 1);
    end;
    Inc(LimEsq, 2); Dec(LimDir, 2);
    if (LimSup < 13) then Inc(LimSup);
    if (LimInf > 13) then Dec(LimInf);
  until (LimEsq >= LimDir);
  i := 1;  quant := 0;
  repeat
    novo := true;
    for k := 1 to i - 1 do
      if (a[k] = a[i]) then novo := false;
    if novo then
    begin
      Inc(quant);
      m[quant] := a[i] div 2 + 1;
    end;
    Inc(i);
  until (quant = 2000);
  for i := 1 to 2000 do n[i] := m[2001 - i];
  Assign(arq, 'IMPLODE');
  Rewrite(arq);
  Write(arq, m);
  Close(arq);
  Assign(arq, 'EXPLODE');
  Rewrite(arq);
  Write(arq, n);
  Close(arq);
end;

{ --------------------------------------------------------------------------- }

procedure GravaTelaTexto(NomeArq: string);

var
  tela: TelaPtr;
  ArqTela: file of MTela;

begin
  New(tela);
  Assign(ArqTela, NomeArq);
  {$I-}
  Rewrite(ArqTela);
  {$I+}
  if (IOResult <> 0) then Halt;
  Move(Mem[EndTela:0000], tela^, 4000);
  Write(ArqTela, tela^);
  Close(ArqTela);
  Dispose(tela);
end;

{ --------------------------------------------------------------------------- }

procedure Moldura;

var
  i: byte;

begin
  Cls;
  Window(10,5,71,21); Cor(1,7);
  for i := 2 to 16 do
  begin
    GoToXY(1, i); Write(#186);
    GoToXY(61, i); Write(#186);
  end;
  GoToXY(1,1); Write(#201, Repete(59, #205), #187);
  GoToXY(26,1); Write(' MATRIZ M ');
  GoToXY(1,9); Write(#204, Repete(59, #205), #185);
  GoToXY(1,17); Write(#200, Repete(59, #205), #188);
  Window(11,6,69,12); Cor(2,0); ClrScr;
  Window(11,14,69,20); Cor(2,7); ClrScr;
  Window(10, 22, 70, 22); Cor(7, 0); ClrScr;
end;

{ --------------------------------------------------------------------------- }

procedure ModoDeEntrada;

var
  cod: integer;
  i: byte;

const
  menu: array[1..4] of string =
       ('       SELECIONE O MODO DE ENTRADA DA MATRIZ      ',
        '   [1] A matriz ser' + #160 + ' introduzida pelo teclado     ',
        '   [2] A matriz ser' + #160 + ' carregada do disco           ',
        '   [3] A matriz ser' + #160 + ' gerada aleatoriamente        ');

begin
  Cls;
  Window(15, 8, 67, 18);
  Cor(2, 7);
  for i := 2 to 10 do
  begin
    GoToXY(1, i); Write(#186);
    GoToXY(52, i); Write(#186);
  end;
  GoToXY(1, 1);  Write(#201, Repete(50, #205), #187);
  GoToXY(1, 3);  Write(#204, Repete(50, #205), #185);
  GoToXY(1, 11); Write(#200, Repete(50, #205), #188);
  GoToXY(2, 2);
  Cor(7, 0); Write(menu[1]);
  Cor(2, 7); GoToXY(2, 4);
  Write(Spc(50)); GoToXY(2, 5);
  Write(menu[2]);
  GoToXY(2, 6); Write(Spc(50));
  GoToXY(2, 7);
  Write(menu[3]);
  GoToXY(2, 8); Write(Spc(50));
  GoToXY(2, 9);
  Write(menu[4]);
  GoToXY(2, 10); Write(Spc(50));
end;

{ --------------------------------------------------------------------------- }

procedure LeTeclado;

var m, n: shortint; tipo: shortint;

var
  c : integer;
  x : string[20];
  Valor1, Valor2: real;
  i, j, l, col, compr, barra: shortint;

begin
  Cls;
  Window(4, 4, 76, 7);
  Cor(1, 7);
  GoToXY(1, 1); Writeln(#218, Repete(70, #196), #191);
  for i := 2 to 4 do
  begin
    GoToXY(1,i); Write(#179, Spc(70), #179);
  end;
  GoToXY(1, 4);
  Write(#195, Repete(70, #196), #180);
  Cor(2, 0); GoToXY(2, 2);
  Write(Spc(10),'Escreva a matriz no formato  usual, digitando cada linha ');
  Write(#133, '  ');
  GoToXY(2, 3);
  Write(' direita do s', #161, 'mbolo  ', #16, ' , pressionando ');
  Writeln('[ENTER] ao final de cada linha. ' );
  Window(4, 8, 76, 24);
  Cor(1, 7);
  for i := 1 to 15 do
  begin
    GoToXY(1, i); Write(#179, Spc(70), #179);
  end;
  GoToXY(1, 16); Write(#192, Repete(70, #196), #217);
  Cor(1, 7);
  Window(5, 8, 75, 24);
end;

{ --------------------------------------------------------------------------- }

procedure MenuPrincipal;

var
  nome: string;
  ch: char;
  n: shortint;
  tam1, tam2, nulid, i, j: byte;

const
  MatMenu : array[1..9] of string[80] =
             (' 0. Nulidade &         4. Polinmio         7. Polinmio  ',
              '    Determinante          caracterstico       mnimo     ',
              '                                                          ',
              ' 1. Inversa                n                8. Autovetores',
              '                       5. M                    reais      ',
              ' 2. Escalonamento                                         ',
              '                           -1               9. Forma de   ',
              ' 3. Autovalores        6. P  MP                Jordan     ',
              ' F1: Inf.  F2: Salva   F3: Nova matriz   F4: Rac.  F5: Fim');

begin
  Cls; LowVideo;
  for i := 1 to 79 do
    for j := 1 to 25 do
    begin
      GoToXY(i, j); Write(#176); { ** }
    end;
  for i := 12 to 72 do
    for j := 3 to 24 do
    begin
      GoToXY(i, j); Write(' '); { trocar com ** acima para os arquivos *.SCR }
    end;
  NormVideo;
  Cor(2, 7);
  for i := 3 to 22 do
  begin
    GoToXY(10,i); Write(#186);
    GoToXY(70,i); Write(#186);
  end;
  GoToXY(10, 2) ; Write(#201, Repete(59, #205), #187);
  GoToXY(10, 10); Write(#204, Repete(59, #205), #185);
  GoToXY(10, 21); Write(#204, Repete(59, #205), #185);
  GoToXY(10, 23); Write(#200, Repete(59, #205), #188);
  GoToXY(36, 2) ; Write(' MATRIZ M ');
  Window(11, 11, 69, 20);
  Cor(2, 0); ClrScr;
  Writeln;
  for i := 1 to 8 do Writeln(MatMenu[i]);
  Window(11, 22, 69, 22);
  Cor(7, 0); ClrScr;
  Write(MatMenu[9]);
  Window(11, 3, 69, 9); Cor(1, 7); ClrScr;
end;

{ --------------------------------------------------------------------------- }

procedure TelaInicial;

var
  i: byte;

procedure CaracGrande(col, linha, ParaImprimir, NumCarac: integer);

type
  DesenhoCarac = array[1..8] of byte;

var
  tabela: array[0..255] of DesenhoCarac absolute $F000:$FA6E;
  x, y: integer;
  padrao: DesenhoCarac;

begin
  padrao := tabela[ParaImprimir];
  for x := 1 to 8 do
    for y := 7 downto 0 do
    begin
      GoToXY((col - 1) + 8 - y, (linha - 1) + x);
      if Odd(padrao[x] shr y) then Write(Chr(NumCarac));
    end;
end;

procedure ALC;

var
  linha, col: byte;

begin
  col := 20; linha := 8;
  CaracGrande(col, linha, Ord('A'), 178); Inc(col, 16);
  CaracGrande(col, linha, Ord('L'), 178); Inc(col, 16);
  CaracGrande(col, linha, Ord('C'), 178);
end;

begin
  Cls; Window(1, 1, 24, 80); Cor(2, 7);
  Write(#201, Repete(78, #205), #187);
  for i := 2 to 23 do
  begin
    GoToXY(1, i);  Write(#186);
    if (i >= 3) and (i <= 22) then
      if (i = 3) then
      begin
        GoToXY(5, i); Write(#201, Repete(70, #205), #187)
      end
     else if (i = 22) then
     begin
        GoToXY(5, i); Write(#200, Repete(70, #205), #188)
     end
      else
        begin
          GoToXY(5, i); Write(#186, Spc(71)); GoToXY(76, i);  Write(#186);
        end;
      GoToXY(80, i); Write(#186);
    end;
  Write(#200, Repete(78, #205), #188);
  Cor(2, 0); ALC;
  GoToXY(19, 18); Write('ALGEBRA LINEAR COMPUTACIONAL - VERSAO 2.0');
  GoToXY(19, 20); Write('(C) 1989, 1991 - Lenimar Nunes de Andrade');
end;

{ --------------------------------------------------------------------------- }

procedure Tela2;

var
  i: byte;

begin
  Cls; Window(1, 1, 24, 80); Cor(3, 7);
  Write(#201, Repete(78, #205), #187);
  for i := 2 to 23 do
  begin
    GoToXY(1, i);  Write(#186);
    if (i >= 3) and (i <= 22) then
      if (i = 3) then
      begin
        GoToXY(5, i); Write(#201, Repete(70, #205), #187)
      end
     else if (i = 22) then
     begin
        GoToXY(5, i); Write(#200, Repete(70, #205), #188)
     end
      else
        begin
          GoToXY(5, i); Write(#186, Spc(71)); GoToXY(76, i);  Write(#186);
        end;
      GoToXY(80, i); Write(#186);
    end;
  Write(#200, Repete(78, #205), #188);
  Cor(3, 0);
  GoToXY(19, 5); Write('ALC - ALGEBRA LINEAR COMPUTACIONAL - VERSAO 2.0');
  GoToXY(19, 7); Write('Fornecendo-se uma matriz quadrada n x n, 2 ', #243,
                                                                    ' n ');
  Write(#243, ' ', MaxM, ',');
  GoToXY(12, 8); Write(' calculado:');
  GoToXY(12, 10); Write('- A matriz inversa, o determinante e a nulidade');
  GoToXY(12, 11); Write('- Uma forma escalonada da matriz');
  GoToXY(12, 12); Write('- Uma potncia da matriz e uma matriz semelhante');
  GoToXY(12, 13); Write('- Polinmios caracterstico e mnimo');
  GoToXY(12, 14); Write('- Autovalores e autovetores reais');
  GoToXY(12, 15); Write('- A forma cannica de Jordan e sua respectiva base');
  GoToXY(19, 17); Write('As opoes dos menus sao  efetuadas  pressionando-se');
  GoToXY(12, 18); Write('uma tecla numrica (0-9) ou uma tecla de funoes ',
                                                                  '(F1-F10).');
  GoToXY(19, 19); Write('Para maiores  informaoes use o  tem "F1: Inf." do');
  GoToXY(12, 20); Write('menu principal.  Para continuar  pressione qualquer ');
  Write('tecla.');
end;

{ --------------------------------------------------------------------------- }

procedure MolduraInf(pag: byte);

var
  i: byte;

begin
  Cls; Window(1, 1, 79, 24); Cor(2, 6); clrscr;
  Write(#213, Repete(77, #205), #184);
  GoToXY(34, 1); Write(' INFORMA', #128, 'OES ');
  for i := 2 to 23 do
  begin
    GoToXY(1, i); Write(#179);
    GoToXY(79, i); Write(#179);
  end;
  GoToXY(1, 23);
  Write(#212, Repete(77, #205), #190);
  Window(1, 24, 79, 24); Cor(7, 0); clrscr;
  GoToXY(5, 1); Write(#26,' : P', #160, 'gina seguinte');
  GoToXY(30, 1); Write(#27,' : P', #160, 'gina anterior');
  GoToXY(54, 1); Write('ESC : Volta');
  GoToXY(70, 1); Write('pag. ', pag);
  Window(2, 2, 78, 22); Cor(2, 0);
end;

{ --------------------------------------------------------------------------- }

procedure SalvaTelasInfo;

var
  info: text;
  PagStr, x: string;
  pag, linhas: byte;

begin
  pag := 1;
  linhas := 0;
  Assign(info, 'INFO.DOC');
  Reset(info);
  while (not Eof(info)) do
  begin
    MolduraInf(pag); Writeln;
    repeat
      Readln(info, x);
      Writeln(x);
      Inc(linhas);
    until Eof(info) or (linhas mod 19 = 0);
    Str(pag, PagStr);
    GravaTelaTexto('INFO' + PagStr);
    Inc(pag);
  end;
  Close(info);
end;

{ --------------------------------------------------------------------------- }

begin
  TelaInicial;     GravaTelaTexto('TELA0');  { ou 'TELA0.SCR' }
  MenuPrincipal;   GravaTelaTexto('TELA1');  { ou 'TELA1.SCR' }
  Moldura;         GravaTelaTexto('TELA2');  { ou 'TELA2.SCR' }
  ModoDeEntrada;   GravaTelaTexto('TELA3');  { ou 'TELA3.SCR' }
  LeTeclado;       GravaTelaTexto('TELA4');  { ou 'TELA4.SCR' }
  Tela2;           GravaTelaTexto('TELA5');  { ou 'TELA5.SCR' }
(*
  GeraIndicesExplosao;
  GeraIndicesEsfarelamento;
  SalvaTelasInfo;
*)
end.

{ =========================================================================== }

