{ =========================================================================== }
{                                MATDEMO.PAS                                  }
{ =========================================================================== }

{$E+,N+,R+,S+,B-,V-}

{$M 65520, 0, 655200}

program MatDemo;

{ ---> Operacoes com matrizes (matriz inversa, determinante, etc. )          }

uses
  Crt, Matrizes, FPTCBas;

var
  mat, aux, p, ident: matriz;
  racional, n, i, j: shortint;
  op1, op2: string;
  resp, opcao1, opcao2: char;
  falha, inversivel: boolean;
  opcao, tam1, tam2: byte;
  determinante: real;
  imp: InfoPress;

const
  erro = 0.00000001;
  msg: array[1..19] of string[80] =
  ('          Ŀ',
   '                                                                      ',
   '             Forma de usar  MATDEMO opcao1 opcao2                    ',
   '                                                                      ',
   '             onde                                                     ',
   '                                                                      ',
   '                  opcao1 = R se os elementos da matriz  forem  apre-  ',
   '                           sentados no formato real (XX.XXXX)         ',
   '                                                                      ',
   '                  opcao1 = Q se os elementos  da matriz  forem apre-  ',
   '                           sentados no formato racional (p/q)         ',
   '                                                                      ',
   '                  opcao2 = T se a matriz entrar pelo teclado          ',
   '                                                                      ',
   '                  opcao2 = A se a matriz for gerada aleatoriamente    ',
   '                                                                      ',
   '             Exemplo  MATDEMO R T                                    ',
   '                                                                      ',
   '          ');

begin
  if (ParamCount > 0) then
  begin
    op1 := ParamStr(1);
    op2 := ParamStr(2);
  end;
  if (ParamCount >= 1) then opcao1 := UpCase(op1[1]) else opcao1 := ' ';
  if (ParamCount >= 2) then opcao2 := UpCase(op2[1]) else opcao2 := ' ';
  if (ParamCount = 0) or ((opcao1 <> 'R') and (opcao1 <> 'Q')) then
  begin
    ClrScr; Writeln(#7);
    for i := 1 to 19 do Writeln(msg[i]);
    Writeln; Halt;
  end;
  imp.opcao := 0; imp.largura := 79; imp.tela := 1;
  if (opcao1 = 'Q') then imp.racional := 1 else imp.racional := 0;
  repeat
  ClrScr;
  if (opcao2 = 'A') then
  begin
    Write('Ordem da matriz (de 2 a ', MaxM, ') : ');
    Readln(mat.m); mat.n := mat.m;
    GeraMatrizAleatoria(mat, 0);
  end
  else
  begin
    Write('FORNECA A ORDEM E OS ELEMENTOS DA MATRIZ QUADRADA M ');
    Writeln('([Ctrl][Break] para parar)'); Writeln;
    Write('Ordem da matriz (de 2 a ', MaxM, ') : ');
    Readln(mat.m); mat.n := mat.m;
    LeMatriz(mat, 0);
  end;
  aux := mat; ClrScr;
  Mens(' MATRIZ M ', imp);
  Writeln; MostraMatriz(mat, imp); Writeln;
  Writeln(Repete(imp.largura, '-'));

  Writeln; Write('Forneca o modo do escalonamento (1, 2 ou 3) : ');
  Readln(opcao);
  Writeln; Writeln('MATRIZ M ESCALONADA : '); Writeln;
  EscalonaMatriz(aux, opcao);
  MostraMatriz(aux, imp);
  Writeln; Writeln('NULIDADE DE M = ', Nul(aux));
  Writeln; Write('Pressione [ENTER] para continuar.');
  Readln; Readln; Writeln;
  Writeln(Repete(imp.largura, '-'));

  Writeln; aux := mat;
  InverteMatriz(aux, inversivel);
  if (not inversivel) then
    Writeln('*** M NAO POSSUI INVERSA ***')
  else
  begin
    Writeln('MATRIZ INVERSA DE M : ');  Writeln;
    MostraMatriz(aux, imp);
    Writeln; falha := false;
    MultiplicaMatrizes(aux, mat, ident);
    for i := 1 to aux.m do
      for j := 1 to aux.n do
        if (i = j) then
        begin
          if (Abs(ident.a[i, j] - 1) > erro) then falha := true;
        end
        else
          if (Abs(ident.a[i, j]) > erro) then falha := true;
    if falha then
      Writeln('*** MATRIZ INVERSA COM ALGUM PROBLEMA ***')
    else
      Writeln('*** MATRIZ INVERSA TESTADA ***');
  end;
  determinante := Det(mat);
  FormataElemento(determinante, tam1, tam2);
  Writeln; Write('DETERMINANTE DE M = ');
  if (opcao1 = 'Q') then
  begin
    ReformataElemento(determinante, tam1, tam2);
    Writeln(Rac(determinante, tam1, tam2));
  end
  else
    if (tam1 = 0) then
       Writeln(determinante:0)
    else
      Writeln(determinante:tam1:tam2);
  Writeln; Write('Pressione [ENTER] para continuar.');
  Readln; Writeln;
  Writeln(Repete(imp.largura, '-'));

  Writeln; Write('Quer calcular alguma potencia de M? (s/n) ');
  Readln(resp); resp := UpCase(resp); aux := mat; Writeln;
  if (resp = 'S') then
  begin
    Write('Forneca o expoente (de -127 a 127) : '); Readln(n); Writeln;
    ElevaMatriz(aux, n);
    MostraMatriz(aux, imp);
    Writeln;
    Write('[ENTER] : entrar com nova matriz / [Ctrl][Break] : encerrar ');
    Readln; Readln;
  end;
  until (1 > 2)
end.

{ =========================================================================== }

