{ =========================================================================== }
{                                SISDEMO.PAS                                  }
{ =========================================================================== }

{$E+,N+,R+,S+,B-,V-}

{$M 65520, 0, 655200}

program SisDemo;

{ ---> Resolucao de sistemas lineares                                        }

uses
  Crt, Matrizes, FPTCBas;

var
  sol: vetor;
  solucao: resposta;
  mat, aux: matriz;
  i, j, tam1, tam2, PosicaoX, PosicaoY: byte;
  opcao1, opcao2: char;
  op1, op2: string;
  op: InfoPress;

const
  mens: array[1..21] of string[80] =
  ('          Ŀ',
   '                                                                      ',
   '             Forma de usar  SISDEMO opcao1 opcao2                    ',
   '                                                                      ',
   '             onde                                                     ',
   '                                                                      ',
   '                  opcao1 = R se os numeros da solucao forem apresen-  ',
   '                           tados no formato real (XX.XXXX)            ',
   '                                                                      ',
   '                  opcao1 = Q se os numeros da solucao forem apresen-  ',
   '                           tados no formato racional (p/q)            ',
   '                                                                      ',
   '                  opcao2 = T se a matriz do sistema  entrar pelo te-  ',
   '                           clado                                      ',
   '                                                                      ',
   '                  opcao2 = A se a matriz do sistema for gerada alea-  ',
   '                           toriamente                                 ',
   '                                                                      ',
   '             Exemplo  SISDEMO Q A                                    ',
   '                                                                      ',
   '          ');

{ --------------------------------------------------------------------------- }

procedure TestaSolucao(mat: matriz; solucao: resposta);

var
  i, j, k, xpos, ypos, QuantLinhaNula: byte;
  falha: boolean;
  soma: real;

const
  erro = 0.0000001;

begin
  falha := false;
  for i := 1 to mat.m do
  begin
    soma := 0;
    for j := 1 to solucao.x.n do
      soma := soma + solucao.SolParticular[j]*mat.a[i, j];
    if (Abs(soma - mat.a[i, mat.n]) > erro) then falha := true;
  end;
  Writeln;
  xpos :=  WhereX; ypos := WhereY;
  if falha then
  begin
    if solucao.SistDet then
    begin
      Write(#7, '*** SOLUCAO COM ALGUM PROBLEMA ***');
      Exit;
    end
    else
    begin
      Write(#7, '*** SOLUCAO PARTICULAR COM ALGUM PROBLEMA ***');
      Readln;
    end
  end
  else
  begin
    if solucao.SistDet then
    begin
      Write('*** SOLUCAO TESTADA ***');
      Delay(2000); GoToXY(xpos, ypos); ClrEol;
      Exit;
    end
    else
    begin
      Write('*** SOLUCAO PARTICULAR TESTADA ***');
      Delay(1500); GoToXY(xpos, ypos); ClrEol;
    end;
  end;
  falha := false;
  for k := 1 to solucao.x.m do
    for i := 1 to mat.m do
    begin
      soma := 0;
      for j := 1 to solucao.x.n do
        soma := soma + solucao.x.a[k, j]*mat.a[i, j];
      if (Abs(soma) > erro) then falha := true;
    end;
    if falha then
    begin
      GoToXY(xpos, ypos); ClrEol;
      Write(#7, '*** SOLUCAO GERAL COM ALGUM PROBLEMA ***');
      Exit;
    end;
    if (mat.m < mat.n - 1) then
    begin
      for i := (mat.m + 1) to (mat.n - 1) do
        for j := 1 to mat.n do mat.a[i, j] := 0;
      mat.m := mat.n - 1;
    end;
    if (solucao.x.m <> Nul(mat)) then
    begin
      Write(#7, '*** SOLUCAO GERAL INCOMPLETA ***');
      Readln;
    end
    else
    begin
      Write('*** SOLUCAO GERAL TESTADA ***');
      Delay(2000);
    end;
    GoToxY(xpos, ypos); ClrEol;
  end;

{ --------------------------------------------------------------------------- }

begin
  if (ParamCount > 0) then
  begin
    op1 := ParamStr(1);
    op2 := ParamStr(2);
  end;
  if (ParamCount >= 1) then opcao1 := UpCase(op1[1]) else opcao1 := ' ';
  if (ParamCount >= 2) then opcao2 := UpCase(op2[1]) else opcao2 := ' ';
  if (ParamCount = 0) or ((opcao1 <> 'R') and (opcao1 <> 'Q')) then
  begin
    ClrScr; Writeln(#7);
    for i := 1 to 21 do Writeln(mens[i]);
    Writeln; Halt;
  end;
  repeat
  ClrScr;
  Writeln('FORNECA A MATRIZ COMPLETA DO SISTEMA ( [Ctrl][Break] para parar )');
  Writeln;
  if (opcao2 = 'A') then
    GeraMatrizAleatoria(mat, 1)
  else
    LeMatriz(mat, 1);
  ClrScr; Writeln('Matriz do sistema :'); Writeln;
  op.tela := 1; op.largura := 80; op.opcao := 0;
  MostraMatriz(mat, op); Writeln;
  PosicaoX := WhereX; PosicaoY := WhereY;
  Write('Resolvendo o sistema...');
  ResolveSistema(mat, solucao);
  if solucao.impossivel then
  begin
    GoToXY(PosicaoX, PosicaoY); ClrEol;
    Writeln('SISTEMA SEM SOLUCAO');
  end
  else
  begin
    if solucao.EqDemais then
    begin
      GoToXY(PosicaoX, PosicaoY); Inc(PosicaoY, 2);
      Writeln('SISTEMA COM EQUACOES DEMAIS'); Writeln;
    end;
    GoToXY(PosicaoX, PosicaoY);
    Write('Formatando a solucao do sistema...');
    if solucao.SistDet then
      aux.m := 1
    else
      aux.m := solucao.x.m + 1;
    aux.n := solucao.x.n;
    for j := 1 to aux.n do aux.a[1, j] := solucao.SolParticular[j];
    if not solucao.SistDet then
      for i := 1 to solucao.x.m do
        for j := 1 to solucao.x.n do
          aux.a[i + 1, j] := solucao.x.a[i, j];
    FormataMatriz(aux, tam1, tam2);
    if (opcao1 = 'Q') then ReformataMatriz(aux, tam1, tam2);
    if solucao.SistDet then
    begin
      GoToXY(PosicaoX, PosicaoY); ClrEol;
      Writeln('Solucao unica :'); Writeln; Write('    ( ');
      for i := 1 to mat.n - 1 do
        if (opcao1 = 'R') then
          Write(solucao.SolParticular[i]:tam1:tam2)
        else
          Write(Rac(solucao.SolParticular[i], tam1, tam2));
      Writeln('  )');
    end
    else
    begin
      GoToXY(PosicaoX, PosicaoY); ClrEol;
      Writeln('Solucao geral : '); Writeln;
        if not solucao.homogeneo then
        begin
          Write('       (');
          for j := 1 to mat.n - 1 do
            if (opcao1 = 'R') then
              Write(solucao.SolParticular[j]:tam1:tam2)
            else
              Write(Rac(solucao.SolParticular[j], tam1, tam2));
          Writeln(' ) + ');
        end;
      for i := 1 to solucao.x.m do
      begin
        if (i > 1) or (not solucao.homogeneo) then
          Write(' + ')
        else
          Write('   ');
        Write(' k', i, '*(');
        for j := 1 to solucao.x.n do
          if (opcao1 = 'R') then
            Write(solucao.x.a[i, j]:tam1:tam2)
          else
            Write(Rac(solucao.x.a[i, j], tam1, tam2));
        Write(' )');
        if (i < solucao.x.m) then Write(' + ');
        Writeln;
      end;
      Writeln; Write('---> ');
      if (solucao.x.m > 1) then
      begin
        for i := 1 to solucao.x.m - 1 do Write('k', i, ', ');
        Writeln('k', solucao.x.m, ' sao numeros reais quaisquer.');
      end
      else
        Writeln('k1 e'' um numero real qualquer.');
    end;
  end;
  if (not solucao.EqDemais) and (not solucao.Impossivel) then
    TestaSolucao(mat, solucao);
  Readln; Readln;
  until (1 > 2)
end.

{ =========================================================================== }

